Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Public Attributes | Friends | List of all members
CollisionCapsule Class Reference

This implements a solid consisting of a cylinder with hemispherical endcaps, also known as a capsule or a spherocylinder. More...

`#include "collisionCapsule.h"`

Inheritance diagram for CollisionCapsule:

## Public Member Functions
| CollisionCapsule (const CollisionCapsule &copy)
| CollisionCapsule (const LPoint3 &a, const LPoint3 &db, PN_stdfloat radius)
| CollisionCapsule (PN_stdfloat ax, PN_stdfloat ay, PN_stdfloat az, PN_stdfloat bx, PN_stdfloat by, PN_stdfloat bz, PN_stdfloat radius)
virtual TypeHandle | force_init_type ()
virtual LPoint3 | get_collision_origin () const
| Returns the point in space deemed to be the "origin" of the solid for collision purposes.
const LPoint3 & | get_point_a () const
const LPoint3 & | get_point_b () const
PN_stdfloat | get_radius () const
virtual PStatCollector & | get_test_pcollector ()
| Returns a PStatCollector that is used to count the number of intersection tests made against a solid of this type in a given frame.
virtual TypeHandle | get_type () const
virtual PStatCollector & | get_volume_pcollector ()
| Returns a PStatCollector that is used to count the number of bounding volume tests made against a solid of this type in a given frame.
virtual CollisionSolid * | make_copy ()
virtual void | output (std::ostream &out) const
void | set_point_a (const LPoint3 &a)
void | set_point_a (PN_stdfloat x, PN_stdfloat y, PN_stdfloat z)
void | set_point_b (const LPoint3 &b)
void | set_point_b (PN_stdfloat x, PN_stdfloat y, PN_stdfloat z)
void | set_radius (PN_stdfloat radius)
virtual PointerTo< CollisionEntry > | test_intersection (const CollisionEntry &entry) const
virtual void | write_datagram (BamWriter *manager, Datagram &dg)
| Writes the contents of this object to the datagram for shipping out to a Bam file.
virtual void | xform (const LMatrix4 &mat)
| Transforms the solid by the indicated matrix.
Public Member Functions inherited from CollisionSolid
| CollisionSolid (const CollisionSolid &copy)
void | clear_effective_normal ()
| Removes the normal previously set by set_effective_normal().
| CPT (BoundingVolume) get_bounds() const
const LVector3 & | get_effective_normal () const
| Returns the normal that was set by set_effective_normal().
bool | get_respect_effective_normal () const
bool | has_effective_normal () const
| Returns true if a special normal was set by set_effective_normal(), false otherwise.
bool | is_tangible () const
virtual | PT (CollisionEntry) test_intersection(const CollisionEntry &entry) const
virtual | PT (PandaNode) get_viz(const CullTraverser *trav
void | set_bounds (const BoundingVolume &bounding_volume)
void | set_effective_normal (const LVector3 &effective_normal)
| Records a false normal for this CollisionSolid that will be reported by the collision system with all collisions into it, instead of its actual normal.
void | set_respect_effective_normal (bool respect_effective_normal)
void | set_tangible (bool tangible)
virtual void | write (std::ostream &out, int indent_level=0) const
Public Member Functions inherited from CopyOnWriteObject
| CopyOnWriteObject (const CopyOnWriteObject &copy)
void | operator= (const CopyOnWriteObject &copy)
Public Member Functions inherited from CachedTypedWritableReferenceCount
void | cache_ref () const
| Explicitly increments the cache reference count and the normal reference count simultaneously.
void | cache_ref_only () const
| Decrements the cache reference count without affecting the normal reference count.
bool | cache_unref () const
| Explicitly decrements the cache reference count and the normal reference count simultaneously.
int | get_cache_ref_count () const
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
Public Member Functions inherited from TypedWritableReferenceCount
| TypedWritableReferenceCount (const TypedWritableReferenceCount &copy)
virtual ReferenceCount * | as_reference_count ()
| Returns the pointer cast to a ReferenceCount pointer, if it is in fact of that type.
void | operator= (const TypedWritableReferenceCount &copy)
Public Member Functions inherited from TypedWritable
| TypedWritable (const TypedWritable &copy)
virtual int | complete_pointers (TypedWritable **p_list, BamReader *manager)
| Receives an array of pointers, one for each time manager->read_pointer() was called in fillin().
vector_uchar | encode_to_bam_stream () const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and returns that data as a bytes object.
bool | encode_to_bam_stream (vector_uchar &data, BamWriter *writer=nullptr) const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and stores that data in the indicated string.
virtual void | finalize (BamReader *manager)
| Called by the BamReader to perform any final actions needed for setting up the object after all objects have been read and all pointers have been completed.
UpdateSeq | get_bam_modified () const
| Returns the current bam_modified counter.
void | mark_bam_modified ()
| Increments the bam_modified counter, so that this object will be invalidated and retransmitted on any open bam streams.
void | operator= (const TypedWritable &copy)
virtual bool | require_fully_complete () const
| Some objects require all of their nested pointers to have been completed before the objects themselves can be completed.
virtual void | update_bam_nested (BamWriter *manager)
| Called by the BamWriter when this object has not itself been modified recently, but it should check its nested objects for updates.
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.

## Static Public Member Functions
static void | flush_level ()
| Flushes the PStatCollectors used during traversal.
static TypeHandle | get_class_type ()
static void | init_type ()
static void | register_with_read_factory ()
| Tells the BamReader how to create objects of type CollisionCapsule.
Static Public Member Functions inherited from CollisionSolid
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from CopyOnWriteObject
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from CachedTypedWritableReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedWritableReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
static | PT (TypedWritableReferenceCount) decode_from_bam_stream(vector_uchar data
Static Public Member Functions inherited from TypedWritable
static bool | decode_raw_from_bam_stream (TypedWritable *&ptr, ReferenceCount *&ref_ptr, vector_uchar data, BamReader *reader=nullptr)
| Reads the bytes created by a previous call to encode_to_bam_stream(), and extracts the single object on those bytes.
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Public Attributes
| get_point_a
| get_point_b
| get_radius
| set_point_a
| set_point_b
| set_radius
Public Attributes inherited from CollisionSolid
virtual const CullTraverserData bool bounds_only | const
virtual const CullTraverserData & | data
| get_bounds
| Returns the solid's bounding volume.
| get_collision_origin
| get_respect_effective_normal
| See set_respect_effective_normal().
| is_tangible
| Returns whether the solid is considered 'tangible' or not.
| set_bounds
| Returns the solid's bounding volume.
| set_respect_effective_normal
| This is only meaningful for CollisionSolids that will be added to a traverser as colliders.
| set_tangible
| Sets the current state of the 'tangible' flag.
Public Attributes inherited from CachedTypedWritableReferenceCount
| get_cache_ref_count
| Returns the current reference count.
Public Attributes inherited from TypedWritableReferenceCount
static BamReader * | reader = nullptr)
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.

## Friends
class | CollisionBox

## Additional Inherited Members
Static Public Attributes inherited from TypedWritable
static TypedWritable *const | Null = nullptr

## Detailed Description

This implements a solid consisting of a cylinder with hemispherical endcaps, also known as a capsule or a spherocylinder.

This shape was previously erroneously called CollisionTube.

Definition at line 27 of file collisionCapsule.h.

## Constructor & Destructor Documentation

## ◆ CollisionCapsule() [1/3]

CollisionCapsule::CollisionCapsule | ( | const LPoint3 & | a,
|  | const LPoint3 & | db,
|  | PN_stdfloat | radius )
| inline explicit

Definition at line 17 of file collisionCapsule.I.

## ◆ CollisionCapsule() [2/3]

CollisionCapsule::CollisionCapsule | ( | PN_stdfloat | ax,
|  | PN_stdfloat | ay,
|  | PN_stdfloat | az,
|  | PN_stdfloat | bx,
|  | PN_stdfloat | by,
|  | PN_stdfloat | bz,
|  | PN_stdfloat | radius )
| inline explicit

Definition at line 28 of file collisionCapsule.I.

## ◆ CollisionCapsule() [3/3]

CollisionCapsule::CollisionCapsule | ( | const CollisionCapsule & | copy | ) |
| inline

Definition at line 48 of file collisionCapsule.I.

## Member Function Documentation

## ◆ flush_level()

void CollisionCapsule::flush_level | ( |  | ) |
| inline static

Flushes the PStatCollectors used during traversal.

Definition at line 61 of file collisionCapsule.I.

Referenced by CollisionTraverser::traverse().

## ◆ force_init_type()

virtual TypeHandle CollisionCapsule::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from CollisionSolid.

Definition at line 151 of file collisionCapsule.h.

## ◆ get_class_type()

static TypeHandle CollisionCapsule::get_class_type | ( |  | ) |
| inline static

Definition at line 140 of file collisionCapsule.h.

## ◆ get_collision_origin()

LPoint3 CollisionCapsule::get_collision_origin | ( |  | ) | const
| virtual

Returns the point in space deemed to be the "origin" of the solid for collision purposes.

The closest intersection point to this origin point is considered to be the most significant.

Implements CollisionSolid.

Definition at line 80 of file collisionCapsule.cxx.

## ◆ get_test_pcollector()

PStatCollector & CollisionCapsule::get_test_pcollector | ( |  | ) |
| virtual

Returns a PStatCollector that is used to count the number of intersection tests made against a solid of this type in a given frame.

Reimplemented from CollisionSolid.

Definition at line 98 of file collisionCapsule.cxx.

## ◆ get_type()

virtual TypeHandle CollisionCapsule::get_type | ( |  | ) | const
| inline virtual

Reimplemented from CollisionSolid.

Definition at line 148 of file collisionCapsule.h.

## ◆ get_volume_pcollector()

PStatCollector & CollisionCapsule::get_volume_pcollector | ( |  | ) |
| virtual

Returns a PStatCollector that is used to count the number of bounding volume tests made against a solid of this type in a given frame.

Reimplemented from CollisionSolid.

Definition at line 89 of file collisionCapsule.cxx.

## ◆ init_type()

static void CollisionCapsule::init_type | ( |  | ) |
| inline static

Definition at line 143 of file collisionCapsule.h.

## ◆ make_copy()

CollisionSolid * CollisionCapsule::make_copy | ( |  | ) |
| virtual

Implements CollisionSolid.

Definition at line 45 of file collisionCapsule.cxx.

## ◆ output()

void CollisionCapsule::output | ( | std::ostream & | out | ) | const
| virtual

Reimplemented from CollisionSolid.

Definition at line 106 of file collisionCapsule.cxx.

## ◆ register_with_read_factory()

void CollisionCapsule::register_with_read_factory | ( |  | ) |
| static

Tells the BamReader how to create objects of type CollisionCapsule.

Definition at line 1050 of file collisionCapsule.cxx.

References BamReader::get_factory(), and Factory< Type >::register_factory().

Referenced by init_libcollide().

## ◆ test_intersection()

PointerTo< CollisionEntry > CollisionCapsule::test_intersection | ( | const CollisionEntry & | entry | ) | const
| virtual

Definition at line 53 of file collisionCapsule.cxx.

## ◆ write_datagram()

void CollisionCapsule::write_datagram | ( | BamWriter * | manager,
|  | Datagram & | dg )
| virtual

Writes the contents of this object to the datagram for shipping out to a Bam file.

Reimplemented from CollisionSolid.

Definition at line 1059 of file collisionCapsule.cxx.

References Datagram::add_stdfloat(), and CollisionSolid::write_datagram().

## ◆ xform()

void CollisionCapsule::xform | ( | const LMatrix4 & | mat | ) |
| virtual

Transforms the solid by the indicated matrix.

Reimplemented from CollisionSolid.

Definition at line 61 of file collisionCapsule.cxx.

References CollisionSolid::xform().

## Friends And Related Symbol Documentation

## ◆ CollisionBox

friend class CollisionBox
| friend

Definition at line 156 of file collisionCapsule.h.

## Member Data Documentation

## ◆ get_point_a

const LPoint3 & CollisionCapsule::get_point_a
| inline

Definition at line 69 of file collisionCapsule.h.

## ◆ get_point_b

const LPoint3 & CollisionCapsule::get_point_b
| inline

Definition at line 70 of file collisionCapsule.h.

## ◆ get_radius

PN_stdfloat CollisionCapsule::get_radius
| inline

Definition at line 71 of file collisionCapsule.h.

## ◆ set_point_a

void CollisionCapsule::set_point_a
| inline

Definition at line 69 of file collisionCapsule.h.

## ◆ set_point_b

void CollisionCapsule::set_point_b
| inline

Definition at line 70 of file collisionCapsule.h.

## ◆ set_radius

void CollisionCapsule::set_radius
| inline

Definition at line 71 of file collisionCapsule.h.

The documentation for this class was generated from the following files:

- panda/src/collide/collisionCapsule.h
- panda/src/collide/collisionCapsule.cxx
- panda/src/collide/collisionCapsule.I